--====================================================================
-- nb_command processor
--====================================================================
-- called from leaf orientation function
-- as early as possible in per-frame processing
-- otherwise there are brief visual glitches as one thing changes
-- but others don't

-- previous selection: restore immediately after recognizing command

selP = nil
sameSel = false

-- table of commands:
-- command text (name of selected object) = command function:
-- filled in by the "doit" include file

tb_cmds = {}

-- -------------------
-- command processor
-- -------------------
tb_cmd = function (this_date)

  local sel = celestia:getselection()
  if (sel == selP) then sameSel = true; return 0 end
  sameSel = false

  local sname = sel:name()

    todo = tb_cmds[sname]
    if todo then 
	todo()
-- restore previous selection
    	if (selP ~= nil) then celestia:select(selP) end

	return 1
    end

-- This selection is not recognized as a command: 
-- save it for reversion after next command

	selP = sel
	return 0
end

------------- scripted orbit which invokes the command processor

NB_Command_Processor = function (sscvals)

	local orbit = {}
	orbit.boundingRadius = 1e5

	
	function orbit:position (tjd)
		tb_cmd(tjd)
		return 0, 0, 0
	end

return orbit
end
